#ifndef NONLINEARSOLVER_H_
#define NONLINEARSOLVER_H_
#include "Vector.h"
#include "Matrix.h"
#include "DirectSolver.h"
#include "Function.h"
#include<cstdio>
#include<iostream>
#include<cstdlib>

class NonLinearSolver
{
public:
	NonLinearSolver(function **jacobi, function *f, Vector x0);
	virtual ~NonLinearSolver();	
	Vector solve(int maxIter, double tolerance);
	int getNIterations();
	static function ** alocateJacobi(int n);
	static function* alocateF(int n);
	
private:
	
	int n;
	int nIter;
	function **jacobi;
	function *f;
	Vector x;	
	void copyJacoby(function **dest, function **src);
	void copyF(function *dest, function *src);
	bool stopCriteria(Vector x_0, Vector x_1, double tolerance);
	
};

#endif /*NONLINEARSOLVER_H_*/
