#include "TridiagonalSolver.h"

TridiagonalSolver::TridiagonalSolver(TridiagonalMatrix &A, Vector &b) {
	
	this->A = A;
	this->b = b;
}

TridiagonalSolver::~TridiagonalSolver()
{
}

void TridiagonalSolver::setMatrixA(TridiagonalMatrix &A) {

	this->A = A;

}

void TridiagonalSolver::setVectorB(Vector &b) {

	this->b = b;

}

Vector TridiagonalSolver::gaussElimination() {

	int n = b.getSize()-1;
	Vector lower(n+1);
	Vector principal(n+1);
	Vector upper(n+1);
	Vector x(n+1);
	
	for (int i = 0; i <= n; ++i) {
		upper[i] = A.getUpperDiagonalValue(i);
		principal[i] = A.getPrincipalDiagonalValue(i);
		lower[i] = A.getLowerDiagonalValue(i);
	}
	
	double m;
	
	for(int k = 1; k <= n; k++) {
	
		m = lower[k]/principal[k-1];
		principal[k] = principal[k] - m*upper[k-1];
		b[k] = b[k] - m*b[k-1];
	
	}
	
	x[n] = b[n]/principal[n];
	
	for(int k = n-1; k >=0; k--) {
	
		x[k] = (b[k] - upper[k]*x[k+1])/principal[k];
	
	}
	
	return x;
}
