//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfBSplineBasis.h                                     //
//   Description: B-Spline basis functions                      //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_C_BSPLINE_BASIS_H_
#define _GF_C_BSPLINE_BASIS_H_


#include "gfDefines.h"
#include <vector>
#include "gfAux2DArray.h"


gfInt gfGetBSplineKnotSpan(gfInt n, gfInt d, std::vector<gfDouble>* knot_vector, gfDouble u);
gfInt gfGetBSplineKnotMultiplicity(gfInt n, gfInt d, std::vector<gfDouble>* knot_vector, gfDouble u);
gfDouble gfGetBSplineValue(gfInt d, std::vector<gfDouble>* knot_vector, gfInt i, gfDouble u);
void gfGetBSplineAllValues(gfInt d, std::vector<gfDouble>* knot_vector, gfInt i, gfDouble u, std::vector<gfDouble>* basis);
void gfGetBSplineDerivation(gfInt d, std::vector<gfDouble>* knot_vector, gfInt i, gfDouble u, gfInt n_der, std::vector<gfDouble>* ders);
void gfGetBSplineAllDers(gfInt d, std::vector<gfDouble>* knot_vector, gfInt i, gfDouble u, gfInt n_der, gfAux2DArray<gfDouble>* ders);

#endif