//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfAuxBoundCone.h                                     //
//   Description: Class for cones bounding set of vectors       //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_C_BOUND_CONE_H_
#define _GF_C_BOUND_CONE_H_


#include "gfDefines.h"
#include <vector>
#include "gfVector.h"


class gfAuxBoundCone
{
private:
    gfVector3 m_axis;
    gfDouble m_angle;

public:
    gfAuxBoundCone(void);
    ~gfAuxBoundCone(void);

    GFRESULT CreateFromVectors(std::vector<gfVector3>* vectors);
    GFRESULT CrossProduct(gfAuxBoundCone c1, gfAuxBoundCone  c2);
    GFRESULT ScalarProduct(gfAuxBoundCone second, gfDouble* min, gfDouble* max);
};


#endif