//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfAuxIntersection.h                                  //
//   Description: Utilities for computing intersections         //
//                                                              //
//////////////////////////////////////////////////////////////////

#ifndef _GF_INTERSECTION_UTILS_H_
#define _GF_INTERSECTION_UTILS_H_


#include "gfDefines.h"
#include "gfPoint.h"
#include "gfVector.h"
#include <vector>


GFRESULT gfCompTriBaryCoords(gfPoint3* point, gfPoint3* pt1, gfPoint3* pt2, gfPoint3* pt3, gfDouble* u, gfDouble* v, gfDouble* w);
gfPoint3* gfLinePlaneIntersection(gfPoint3* line_pt1, gfPoint3* line_pt2, gfPoint3* plane_pt, gfVector3* plane_normal);
GFRESULT gfRayPlaneIntersection(gfPoint3* ray_start, gfVector3* ray_dir, gfPoint3* plane_pt, gfVector3* plane_normal, gfDouble* t);
GFRESULT gfRayPlaneIntersection(gfPoint3* ray_start, gfVector3* ray_dir, gfPoint3* plane_pt, gfVector3* plane_base1, gfVector3* plane_base2,
                                gfDouble* ret_u, gfDouble* ret_v, gfDouble* ret_t);
GFRESULT gfRayTriangleInter(gfPoint3* ray_begin, gfVector3* ray_dir, gfPoint3* pt1, gfPoint3* pt2, gfPoint3* pt3, gfDouble* t);
GFRESULT gfRayTriangleInter(gfPoint3* ray_begin, gfVector3* ray_dir, gfPoint3* pt1, gfPoint3* pt2, gfPoint3* pt3, gfDouble* u, gfDouble* v, gfDouble* t);
GFRESULT gfRaySegmentInter(gfPoint3* ray_begin, gfVector3* ray_dir, gfPoint3* seg1, gfPoint3* seg2, gfDouble* t);
GFRESULT gfAxisXConvexHullInter2D(std::vector<gfPoint2>* points, gfDouble* minx, gfDouble* maxx);
GFRESULT gfLinesIntersection(gfPoint3* pt_line1, gfVector3* dir_line1, gfPoint3* pt_line2, gfVector3* dir_line2, gfPoint3* result);

#endif
