//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfNumUtils.h                                         //
//   Description: Numerical functions                           //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_NUM_UTILS_H_
#define _GF_NUM_UTILS_H_


#include "gfDefines.h"
#include "gfVector.h"
#include "gfMatrix.h"
#include <vector>
#include "gfObjGeomObject.h"
#include <math.h>


gfBool gfIsZero(gfDouble numb);
gfDouble gfSquareRoot(gfDouble numb);
gfDouble gfSin(gfDouble numb);
gfDouble gfArcsin(gfDouble numb);
gfDouble gfCos(gfDouble numb);
gfDouble gfArccos(gfDouble numb);
gfLong gfFactorial(gfLong lNumb);
gfDouble gfPower(gfDouble dNumb, gfInt iPow);
gfDouble gfPower(gfDouble dNumb, gfDouble dPow);
gfLong gfCombNumber(gfLong n, gfLong i);
gfLong gfCombNumber3(gfLong n, gfLong i, gfLong j);
gfLong gfCombNumber4(gfLong n, gfLong i, gfLong j, gfLong k);
gfLong gfCombNumberGeneral(std::vector<gfInt> multi_index);
gfDouble gfBernsteinPoly(gfLong n, gfLong i, gfDouble u);
gfDouble gfBernsteinPoly3(gfLong n, gfLong i, gfLong j, gfDouble u, gfDouble v);
gfDouble gfBernsteinPoly4(gfLong n, gfLong i, gfLong j, gfLong k, gfDouble u, gfDouble v, gfDouble w);
gfDouble gfBernsteinPolyGeneral(std::vector<gfInt> multi_index, std::vector<gfDouble> coordinates);

gfInt gfRand();
gfInt gfRand(gfInt max);
gfDouble gfRand(gfDouble max);
gfDouble gfRand(gfDouble min, gfDouble max);
gfDouble gfAbs(gfDouble val);
gfDouble gfClamp(gfDouble min, gfDouble max, gfDouble value);
gfInt gfClamp(gfInt min, gfInt max, gfInt value);
GFRESULT gfSort1DArray(std::vector<gfDouble>* array);
GFRESULT gfSortRayInterInfo(gfRayInterInfo* info);

GFRESULT gfGetEigensSym3x3(gfMatrix3* matrix, gfVector3* eigen_values, gfMatrix3* eigen_vectors, gfInt* nrot);
void gfGetMultiindices(gfInt multi, gfInt sum, std::vector< std::vector<gfInt> >& multiindices);

#endif