//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfKernel.h                                           //
//   Description: Kernel file containing all header files       //
//                                                              //
//////////////////////////////////////////////////////////////////


//#ifndef _GF_KERNEL_H_
//#define _GF_KERNEL_H_

// defines
#include "gfDefines.h"

// basic classes
#include <vector>
#include "gfMatrix.h"
#include <string>
#include "gfVector.h"
#include "gfPoint.h"

// objects
#include "gfObjGeomObject.h"
#include "gfObjPolyLine.h"
#include "gfObjNURBSCurve.h"
#include "gfObjNURBSPatch.h"
#include "gfObjBezierTriangle.h"
#include "gfObjBezierSPatch.h"
#include "gfObjBezierTetrahedra.h"
#include "gfObjBezierSVolume.h"
#include "gfObjNURBSBox.h"
#include "gfObj3DBoxLattice.h"
#include "gfObjHalfEdgeMesh.h"

// bounding volumes
#include "gfAuxBoundingVolume.h"

// utilities
#include "gfAuxNumUtils.h"
#include "gfAuxGeomUtils.h"
#include "gfAuxBSplineBasis.h"
#include "gfAuxLogging.h"

// scene
#include "gfScnCamera.h"

// window utilities
#include "gfWinOGLWindow.h"
#include "gfWinFPSCounter.h"
#include "gfWinOGLExtensions.h"
#include "gfWinOGLPBuffer.h"
#include "gfWinView.h"
#include "gfWinApplication.h"

// factories
#include "gfObjectFactory.h"


//#endif