//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinAboutDlg.h                                      //
//   Description: Window for showing raytraced scene            //
//                                                              //
//////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "resource.h"
#include "gfWinAboutDlg.h"
#include "gfAuxLogging.h"


LRESULT _stdcall gfWinAboutDlg::event(struct HWND__* hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{	
    gfWinAboutDlg* acc_win = (gfWinAboutDlg*)::GetWindowLong(hwnd, GWL_USERDATA);

    switch(msg)
    {
    case WM_INITDIALOG:
        {
            gfWinAboutDlg* acc_win = (gfWinAboutDlg*)lparam;
            ::SetWindowLong(hwnd, GWL_USERDATA, (long) lparam);
            if (acc_win)
            {
                acc_win->m_hWnd = hwnd;
                return acc_win->OnInitDialog(hwnd, msg, wparam, lparam);
            }
        }
        break;
    case WM_COMMAND:
        {
            if (acc_win)
                return acc_win->OnCommand(hwnd, msg, wparam, lparam);
        }
        break;
    case WM_CLOSE:
        {
            if (acc_win)
                return acc_win->OnClose(hwnd, msg, wparam, lparam);
        }
        break;
    case WM_MOVE:
        {
            if (acc_win)
                return acc_win->OnMove(hwnd, msg, wparam, lparam);
        }
        break;
    case WM_PAINT:
        {
            if (acc_win)
                return acc_win->OnPaint(hwnd, msg, wparam, lparam);
        }
        break;
    case WM_KEYDOWN:
        {
            if (acc_win)
                return acc_win->OnKeyDown(hwnd, msg, wparam, lparam);
        }
        break;
    case WM_KEYUP:
        {
            if (acc_win)
                return acc_win->OnKeyUp(hwnd, msg, wparam, lparam);
        }
        break;
    case WM_LBUTTONDBLCLK:
        {
            if (acc_win)
                return acc_win->OnLButtonDblClk(hwnd, msg, wparam, lparam);
        }
        break;
    default: 
        break;
    }

    return 0;
}

gfWinAboutDlg::gfWinAboutDlg(void)
{
}

gfWinAboutDlg::~gfWinAboutDlg(void)
{
    if (m_hWnd)
        DestroyWindow(m_hWnd);
}

LRESULT gfWinAboutDlg::OnInitDialog(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{
    m_hWnd = hwnd;
    return DefWindowProc(hwnd, msg, wparam, lparam);
}

LRESULT gfWinAboutDlg::OnCommand(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{
    switch (LOWORD(wparam)) 
    { 
    case IDOK: 
        EndDialog(m_hWnd, 1);
        m_hWnd = NULL;
        return 1;
    }

    return 0;
}

LRESULT gfWinAboutDlg::OnClose(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{ 
    EndDialog(m_hWnd, 1);
    m_hWnd = NULL;

    return 0;
}

LRESULT gfWinAboutDlg::OnMove(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{
    return 0;
}

LRESULT gfWinAboutDlg::OnKeyDown(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{
    return 0;
}

LRESULT gfWinAboutDlg::OnKeyUp(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{
    return 0;
}

LRESULT gfWinAboutDlg::OnPaint(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{
    return 0;
}

LRESULT gfWinAboutDlg::OnLButtonDblClk(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam)
{
    return 0;
}

GFRESULT gfWinAboutDlg::CreateAboutDialog(HWND parent)
{
    if (m_hWnd)
        DestroyWindow(m_hWnd);

    DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUTBOX), parent, (DLGPROC)event, (LPARAM)this);
    m_hWnd = NULL;

    return GF_S_OK;
}