//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinAboutDlg.h                                         //
//   Description: Window for showing raytraced scene            //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_WIN_ABOUT_H_
#define _GF_WIN_ABOUT_H_

#include <windows.h>
#include "gfDefines.h"


class gfWinAboutDlg
{
private:
    HWND m_hWnd;

    // window proc
    static LRESULT CALLBACK event(struct HWND__* hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);

    // messages to window
    LRESULT OnInitDialog(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnCommand(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnClose(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnMove(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnKeyDown(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnKeyUp(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnPaint(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnLButtonDblClk(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);

public:
    gfWinAboutDlg(void);
    ~gfWinAboutDlg(void);

    GFRESULT CreateAboutDialog(HWND parent);

};

#endif