//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinFPSCounter.cpp                                  //
//   Description: Wrapper for working with FPS                  //
//                                                              //
//////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "gfWinFPSCounter.h"



gfWinFPSCounter::gfWinFPSCounter(void)
{
    m_frames = 0;
    m_LastTick = 0;
    m_BeginTick = 0;
    m_FPS = 0;
}

GFRESULT gfWinFPSCounter::BeginMSCount(void)
{
    m_BeginTick = GetTickCount();
    return GF_S_OK;
}

gfInt gfWinFPSCounter::EndMSCount(void)
{
    return (gfInt) (GetTickCount() - m_BeginTick);
}

gfBool gfWinFPSCounter::SceneUpdated(void)
{
    if (m_frames > 0)
    {
        m_frames++;
        DWORD diff = GetTickCount() - m_LastTick;
        if (diff > 1000)
        {
            //m_FPS = 1000.0 * m_frames / diff;
            m_FPS = m_frames;
            m_frames = 0;
            return 1;
        }
    }
    else
    {
        m_frames++;
        m_LastTick = GetTickCount();
    }

    return 0;
}

gfDouble gfWinFPSCounter::GetFPS(void)
{
    return m_FPS;
}


