//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinFPSCounter.h                                    //
//   Description: Wrapper for working with FPS                  //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_FPS_COUNTER_H_
#define _GF_FPS_COUNTER_H_


#include <windows.h>
#include "gfDefines.h"
#include <string>


class gfWinFPSCounter
{
private:
    gfInt m_frames;
    gfDouble m_BeginTick;
    DWORD m_LastTick;
    gfDouble m_FPS;

public:
    gfWinFPSCounter(void);

    GFRESULT BeginMSCount(void);
    gfInt EndMSCount(void);
    gfBool SceneUpdated(void);
	gfDouble GetFPS(void);

};

#endif