//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinInputDoubleDlg.h                                //
//   Description: Window for input double parameter             //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_WIN_DOUBLE_H_
#define _GF_WIN_DOUBLE_H_

#include <windows.h>
#include "gfDefines.h"
#include <string>


class gfWinInputDoubleDlg
{
private:
    HWND m_hWnd;
    gfDouble m_init_value;
    gfDouble m_value;
    std::string m_param_name;

    // window proc
    static LRESULT CALLBACK event(struct HWND__* hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);

    // messages to window
    LRESULT OnInitDialog(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnCommand(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnClose(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnMove(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnKeyDown(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnKeyUp(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnPaint(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnLButtonDblClk(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);

public:
    gfWinInputDoubleDlg(void);
    ~gfWinInputDoubleDlg(void);

    void SetInitValue(gfDouble value);
    void SetParameterText(char* name);
    GFRESULT CreateDoubleDialog(HWND parent);
    gfDouble GetValue(void);

};

#endif