//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinMaterialEditor.h                                //
//   Description: Window for changing material                  //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_WIN_MATERIAL_WINDOW_H_
#define _GF_WIN_MATERIAL_WINDOW_H_

#include <windows.h>
#include "gfDefines.h"
#include "gfPoint.h"
#include "gfVector.h"
#include "gfScnMaterial.h"


class gfWinMaterialEditor
{
private:

    // current material
    gfScnMaterial* m_material;

    gfBool m_ambient_and_diffuse;
    gfBool m_ambient_diffuse_changing;

    // window proc
    static LRESULT CALLBACK event(struct HWND__* hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);

    // messages to window
    LRESULT OnInitDialog(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnCommand(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnMove(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnKeyDown(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnKeyUp(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnPaint(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnLButtonDblClk(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);

public:
    gfWinMaterialEditor(void);
    ~gfWinMaterialEditor(void);

    gfScnMaterial* CreateMaterialEditorDialog(gfScnMaterial* in_material, HWND parent);
    GFRESULT GetColorFromDialog(HWND owner, gfVector4* color);

};

#endif