//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinOGLPBuffer.h                                    //
//   Description: Wrapper for working with OpenGL pixel buffer  //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_OGL_PBUFFER_H_
#define _GF_OGL_PBUFFER_H_

#include <windows.h>
#include <stdio.h>
#include "gfDefines.h"
#include <string>
#include "gfWinOGLExtensions.h"


class gfWinOGLPBuffer
{
private:
    HGLRC m_hRC;
	HDC m_hDC;
	HPBUFFERARB m_hBuffer;

public:

	GFRESULT CreatePBuffer(gfInt width, gfInt height, gfInt color_bits, gfInt depth_bits, gfInt stencil_bits, 
                            gfInt num_extra_iattribs, gfInt* extra_iattrib_list, gfInt* flags);
    GFRESULT ReleasePBuffer(void);
    void BindToTexture(GLuint texture);
    void ReleaseFromTexture(void);
    GFRESULT MakeCurrent(void);
};

#endif