//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinRaytrace.h                                      //
//   Description: Window for showing raytraced scene            //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef _GF_WIN_RAYTRACE_H_
#define _GF_WIN_RAYTRACE_H_

#include <windows.h>
#include "gfDefines.h"
#include "gfPoint.h"
#include "gfVector.h"
#include "gfAuxRaytracer.h"


class gfWinRaytrace
{
private:
    gfInt m_width, m_height;
    gfAuxRaytracer* m_raytracer;
    gfBool m_raytraced;
    gfBool m_ratio_progress;
    gfBool m_shadows;
    gfBool m_bezier_clipping;
    gfBool m_interleaved;
    gfAntialiasingType m_aa;

    // window proc
    static LRESULT CALLBACK event(struct HWND__* hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);

    // messages to window
    LRESULT OnInitDialog(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnCommand(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnMove(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnKeyDown(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnKeyUp(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnPaint(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);
    LRESULT OnLButtonDblClk(HWND hwnd, unsigned int msg, unsigned int wparam, unsigned long lparam);

public:
    gfWinRaytrace(void);
    ~gfWinRaytrace(void);

    HWND m_hWnd;

    GFRESULT CreateRaytraceDialog(char* title, gfAuxRaytracer* raytracer, HWND parent);

    // save to file
    GFRESULT SaveToBmp(std::string str);
};

#endif