//////////////////////////////////////////////////////////////////
//                                                              //
//   Project: GeomForge                                         //
//   Author: Martin Samuelcik                                   //
//   File: gfWinView.cpp                                        //
//   Description: Camera view for OGL window                    //
//                                                              //
//////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "gfWinView.h"

#include "OGL/glut.h"


gfWinView::gfWinView(void)
{
    m_camera = NULL;

    m_left = 0;
    m_bottom = 0;
    m_width = 0;
    m_height = 0;
}

GFRESULT gfWinView::SetOGLViewport(void)
{
    glViewport(m_left, m_bottom, m_width, m_height);
    return GF_S_OK;
}

gfBool gfWinView::IsPointInside(gfDouble px, gfDouble py)
{
    if (px >= m_left && px <= m_left + m_width && py >= m_bottom && py <= m_bottom + m_height)
        return true;
    else
        return false;
}